% Sample initialization for the Saila-Lorda S-R model of the form
% log(R_t) =  log(k)+c_SL*(log(S_t)-log(S_k))+c_SL(1-S_t/S_k)+e, e~N(0,c_t*sigma))
function post_sample = saila_lorda_2_env_factor_1D_IS_init(T, D, options)

n_particles = options.solver.n_particles;

hyperparameters = options.model.upm.prior.hyperparameters;

switch lower(options.model.upm.prior.type)
     case 'uniformuniformmixuniformuniformuniform' % model with std
        theta(1,:) = unifrnd(hyperparameters.kLow,hyperparameters.kUp,1,n_particles);
        theta(2,:) = unifrnd(hyperparameters.SkLow,hyperparameters.SkUp,1,n_particles);
        theta(3,:) = mixunifrnd(hyperparameters.cLow,hyperparameters.cUp,n_particles);
        theta(4,:) = unifrnd(hyperparameters.dLow,hyperparameters.dUp,1,n_particles);
        sigma = unifrnd(hyperparameters.sigmaLow,hyperparameters.sigmaUp,1,n_particles);
        
        post_sample = [theta ; sigma ; 1/n_particles*ones(1,n_particles)];
   
    otherwise
        error('Undefined prior type')
end