clear
clc
close all

pathBOCPD= 'C:\MyTemp\BOCPD_IrishSeaCase_Dryad\';

cd([pathBOCPD 'BOCPD\'])

% add paths to the subfolders
addallpaths
  
%% cod, PC1
options = setBOCPDoptions_ICES_raw_plankton('SBH','cod7a','PC1',0.05,-2.0,2.0);
fit_data(options,'results_ICES_priors1_no_regularization_raw_PC1',pathBOCPD,10,[348, 5675, 215])

options = setBOCPDoptions_ICES_raw_plankton('SL','cod7a','PC1',0.05,-2.0,2.0);
fit_data(options,'results_ICES_priors1_no_regularization_raw_PC1',pathBOCPD,10,[348, 5675, 215])

%% sol, PC1
options = setBOCPDoptions_ICES_raw_plankton('SBH','sol7a','PC1',0.05,-2.0,2.0);
fit_data(options,'results_ICES_priors1_no_regularization_raw_PC1',pathBOCPD,10,[348, 5675, 215])

options = setBOCPDoptions_ICES_raw_plankton('SL','sol7a','PC1',0.05,-2.0,2.0);
fit_data(options,'results_ICES_priors1_no_regularization_raw_PC1',pathBOCPD,10,[348, 5675, 215])

%% whg, PC1
options = setBOCPDoptions_ICES_raw_plankton('SBH','whg7a','PC1',0.05,-2.0,2.0);
fit_data(options,'results_ICES_priors1_no_regularization_raw_PC1',pathBOCPD,10,[348, 5675, 215])

options = setBOCPDoptions_ICES_raw_plankton('SL','whg7a','PC1',0.05,-2.0,2.0);
fit_data(options,'results_ICES_priors1_no_regularization_raw_PC1',pathBOCPD,10,[348, 5675, 215])

%% cod, SST and PC2
options = setBOCPDoptions_env_combined_ICES_cod('SBH','cod7a',0.05,-2.0,1.0);
fit_data(options,'results_ICES_priors1_no_regularization_SST_and_smoothed_PC2',pathBOCPD,10,[348, 5675, 215])

%% sol, SBT27 and PC2
options = setBOCPDoptions_env_combined_ICES_sol_and_whg('SBH','sol7a',0.05,-2.0,1.0,27,'PC2');
fit_data(options,'results_ICES_priors1_no_regularization_SBT27_and_smoothed_PC2',pathICES,10,[348, 5675, 215])

%% whg, SBT47 and PC1
options = setBOCPDoptions_env_combined_ICES_sol_and_whg('SL','whg7a',0.05,-1.0,1.0,47,'PC1');
fit_data(options,'results_ICES_priors1_no_regularization_SBT47_and_smoothed_PC1',pathICES,10,[348, 5675, 215])

% other models can be fitted similarly
%%

function fit_data(options,folderName,pathICES,hazardConstants,seeds)
    cases=1;
    
    % FIT MODELS 
    for seedNum=seeds
        %
        % RESULTS FILE SETTINGS
        resultsPath = [pathICES folderName '\'];
        resultsFolder=['seed' num2str(seedNum) '\'];
        mkdir([resultsPath resultsFolder]);

        resultsTo=[resultsPath resultsFolder];
        for hazardConstant=hazardConstants
            tic
            %profile -memory on

            hazardSuffix=['_hazard' num2str(hazardConstant)];

            for caseid=cases
                options.model.hazard.hyperparameters=1.0/hazardConstant;

                rng(seedNum);

                Data = prepareBOCPDDATA_env_combined(options); 
                % depending on the model:
                % prepareBOCPDDATA(options); %prepareBOCPDDATA_env(options);

                BCPD_OUTPUT = bocpd_smoother_predicter_IS_memory_efficient(Data, options);
                regstarttimes = findRegStartTimesFast(BCPD_OUTPUT,options);
                BCPD_OUTPUT.regstarttimes=regstarttimes;    

                BCPD_OUTPUTfile=[resultsTo options.data.stocklabel '_BCPD_OUTPUT_' options.model.type hazardSuffix];

                savePlotData_memory_efficient(options,BCPD_OUTPUT,BCPD_OUTPUTfile);


            end
            t=toc;
            disp(['Fitting the model took ' num2str(t) ' seconds.'])

        end
    end
    %clearvars

end
     