% takes the posterior samples for all possible run lengths at time,
% returns the mixture distribution of these posteriors, weighted by the run
% length probabilities
function posteriorSample = drawPosteriorSampleFullOnline(S,post_sample,t,Nsamples)
    Nparams = size(post_sample{1},1)-1;
    
    % weights for samples corresponding to different run lengths
    weights = S(:,t);
    % sample posterior sample indices according to the run length probabilities
    ind_sample = randsample(length(weights),Nsamples,true,weights);
    
    % initialize parameter sample matrix
    parameter_sample=zeros(Nparams,Nsamples);
    for i=1:Nsamples
        post = post_sample{1+ind_sample(i)}; % add one since the first sample in post_sample is prior
        parameter_ind = randsample(1:size(post,2),1,true,post(end,:));
        parameter_sample(:,i) = post(1:Nparams,parameter_ind);
    end
    posteriorSample = parameter_sample;
end