% takes the posterior samples for all possible run lengths at time,
% returns subsamples of them
function posterior_subsamples = drawPosteriorSampleRunspecificOnline(post_sample,t,Nsamples)
    Nparams = size(post_sample{1},1)-1;
    
    for i=1:t
    % weights for samples corresponding to different run lengths
    weights = post_sample{i+1}(Nparams+1,:);
    % sample posterior sample indices according to the run length probabilities
    ind_sample = randsample(length(weights),Nsamples,true,weights);
    
    posterior_subsample = post_sample{i+1}(1:Nparams,ind_sample);
    posterior_subsamples{i} = posterior_subsample;
    end
end