function [Data, options] = prepareBOCPDDATA_env_combined(options)

iNaNs = isnan(options.data.recruits) | isnan(options.data.ssb);
options.data.recruits = options.data.recruits(~iNaNs);
options.data.ssb = options.data.ssb(~iNaNs);
options.data.c = options.data.c(~iNaNs);
options.data.time = options.data.time(~iNaNs);
options.data.env_factor1 = options.data.env_factor1(~iNaNs);
options.data.env_factor2 = options.data.env_factor2(~iNaNs);

R = options.data.recruits;
S = options.data.ssb;
c = options.data.c; 
e1 = options.data.env_factor1;
e2 = options.data.env_factor2;

switch lower(options.model.type)
    case {'saila_lorda_2_env_factor_combined'}
        Data(:,1) = log(R(:));
        Data(:,2) = S(:);
        Data(:,3) = c; %this is related to scaling the variance 
        %when sampling intensity changes
        Data(:,4) = e1;
        Data(:,5) = e2;
    case {'sigmoid_beverton_holt_env_factor_combined'} % check that this corresponds to _predict.main
        Data(:,1) = log(R(:));
        Data(:,2) = S(:);
        Data(:,3) = c; 
        Data(:,4) = e1;
        Data(:,5) = e2;
    otherwise
        error('Undefined model type')
end
